const inquirer = require('inquirer');
const { createServer } = require('./src/app');
const { checkPortIsFree } = require('./src/network-utils');
inquirer
  .prompt([
    {
      type: "confirm",
      name: "sandbox",
      message: "enable sandbox environment",
    },
    {
      type: "input",
      name: "appid",
      message: "appid",
      validate(input) {
        if (!input) {
          return "please input appid";
        }
        return true;
      },
    },
    {
      type: "input",
      name: "secret",
      message: "secret",
      validate(input) {
        if (!input) {
          return "please input appid";
        }
        return true;
      },
    },
    {
      type: "number",
      name: "port",
      message: "port (default 8000)",
      default: 8000,
      validate(input) {
        const done = this.async();
        checkPortIsFree(input)
          .then(() => {
            done(null, true);
          })
          .catch(() => {
            done(`port '${input}' is in use, please input a free one😁`);
          });
      },
    },
  ])
  .then((answers) => {
    const { secret, appid, sandbox, port } = answers;
    createServer(secret, appid, sandbox, port);
  });

