import { loginController } from '../../utils';
Page({
  data: {
    openid: '',
    unionid: '',
    // 抖音登录状态
    isLogin: true,
  },
  async onLoad() {
    // 判断用户是否登录抖音主端
    const isDouyinLogin = await loginController.login(false);
    // setData设置抖音登录状态
    this.setData({
      isLogin: isDouyinLogin,
    });
    // 如果用户已登录开发者服务端，则在缓存中获取openid和unionid
    if (loginController.isDeveloperServerLogin()) {
      this.setData({
        openid: loginController.getOpenid(),
        unionid: loginController.getUnionid(),
      });
      tt.setNavigationBarColor({ frontColor: '#000000', backgroundColor: '#F2F2F2' });
    }
  },
  /**
   * @description: 点击事件，若用户没登录抖音主端，则强制调取登录界面，并向开发者服务端进行登录
   * @return {*}
   */
  async login() {
    const isDouyinLogin = await loginController.login(true);
    this.setData({
      openid: loginController.getOpenid(),
      unionid: loginController.getUnionid(),
      isLogin: isDouyinLogin,
    });
    tt.setNavigationBarColor({ frontColor: '#000000', backgroundColor: '#F2F2F2' });
  },
});
