import { request, loginController } from '../../utils';
Page({
  data: {
    ruleChecked: false,
    showMask: false,
    phoneNumber: null,
    isLogin: true,
  },
  async onLoad() {
    const isDouyinLogin = await loginController.login(false);
    this.setData({
      isLogin: isDouyinLogin,
    });
    const token = loginController.getToken();
    const phoneNumberLogin = tt.getStorageSync('phoneNumberLogin');
    if (loginController.isDeveloperServerLogin() && token && phoneNumberLogin) {
      const res = await request({
        url: '/api/apps/userData',
        method: 'post',
        data: {
          token,
        },
      });
      const userData = JSON.parse(res.data.userData.data);
      this.setData({
        phoneNumber: userData.phoneNumber,
        isLogin: true,
      });
      tt.setNavigationBarColor({ frontColor: '#000000', backgroundColor: '#F2F2F2' });
    }
  },
  async douyinLogin() {
    const isDouyinLogin = await loginController.login(true);
    this.setData({
      isLogin: isDouyinLogin,
    });
  },
  onRuleChecked(e) {
    const { detail } = e;
    if (detail.value.includes('rule')) {
      this.setData({
        ruleChecked: true,
      });
    } else {
      this.setData({
        ruleChecked: false,
      });
    }
  },
  closeMask() {
    this.setData({
      showMask: false,
    });
  },
  showMask() {
    if (!this.data.ruleChecked) {
      this.setData({
        showMask: true,
      });
    }
  },
  async getPhoneNumberHandler(e) {
    const { iv, encryptedData } = e.detail;
    // 用户点了不同意授权
    if (!iv || !encryptedData) {
      tt.showToast({
        title: '请先同意授权',
        icon: 'fail',
      });
      return;
    }
    const token = loginController.getToken();
    // 向开发者服务端请求解密敏感信息
    const res = await request({
      url: '/api/apps/showData',
      method: 'post',
      data: {
        token,
        encryptedData: {
          iv,
          data: encryptedData,
        },
      },
    });
    // 缓存手机登录信息
    tt.setStorageSync('phoneNumberLogin', true);
    const userData = JSON.parse(res.data.decryptedData);
    this.setData({
      phoneNumber: userData.phoneNumber,
      isLogin: true,
      ruleChecked: true,
    });
    tt.setNavigationBarColor({ frontColor: '#000000', backgroundColor: '#F2F2F2' });
  },
  agreeRule() {
    this.closeMask();
    this.setData({
      ruleChecked: true,
    });
  },
  viewRule() {
    tt.navigateTo({
      url: '/pages/rule/rule',
    });
  },
});
