package handler

import (
	"context"

	"code.byted.org/developer/open_microapp_passport_showcase/go/conf"
	"code.byted.org/developer/open_microapp_passport_showcase/go/model"
	"code.byted.org/developer/open_microapp_passport_showcase/go/store"

	"github.com/ggwhite/go-masker"
)

func Login(context context.Context, req *model.LoginRequest) *model.LoginResponse {
	code2SessionReq := &code2SessionRequest{
		AppId:  conf.Appid,
		Secret: conf.Secret,
		Code:   req.Code,
		ACode:  "",
	}

	code2SessionResp, err := code2Session(context, code2SessionReq)

	if err != nil {
		response := &model.LoginResponse{
			ErrCode: -1,
			ErrMsg:  err.Error(),
			Token:   "",
		}
		return response
	}

	if code2SessionResp.ErrNo != 0 {
		response := &model.LoginResponse{
			ErrCode: -1,
			ErrMsg:  code2SessionResp.ErrTips,
			Token:   "",
		}
		return response
	}

	token := store.SetCache(context, "", code2SessionResp.Data.Openid, code2SessionResp.Data.UnionId, "", code2SessionResp.Data.SessionKey)

	response := &model.LoginResponse{
		ErrCode: 0,
		ErrMsg:  "success",
		Token:   token,
		Openid:  masker.ID(code2SessionResp.Data.Openid),
		Unionid: masker.ID(code2SessionResp.Data.UnionId),
	}
	return response
}
