package handler

import (
	"context"

	"code.byted.org/developer/open_microapp_passport_showcase/go/model"
	"code.byted.org/developer/open_microapp_passport_showcase/go/store"
	"code.byted.org/developer/open_microapp_passport_showcase/go/utils"
)

func UserData(context context.Context, req *model.UserDataRequest) *model.UserDataResponse {
	data, exist := store.GetCache(context, req.Token)

	if !exist {
		resp := &model.UserDataResponse{
			ErrCode:  0,
			ErrMsg:   "",
			UserData: nil,
		}
		return resp
	}
	resp := &model.UserDataResponse{
		ErrCode: 0,
		ErrMsg:  "",
		UserData: &model.UserData{
			Data: utils.MaskPhoneNumber(context, data.Data),
		},
	}

	return resp
}
