package open.douyin.com.handler;

import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.util.JsonFormat;
import open.douyin.com.model.Login;
import open.douyin.com.store.Store;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import open.douyin.com.store.Mask;
import open.douyin.com.store.UserSession;

@RestController
public class UserData {

    /**
     * 获取缓存用户数据
     * @param requestBody
     * @return
     */
    @RequestMapping("/api/apps/userData")
    String handle(@RequestBody String requestBody) throws InvalidProtocolBufferException {
        // 请求体初始化pb结构
        open.douyin.com.model.Login.UserDataRequest.Builder requestBuild = open.douyin.com.model.Login.UserDataRequest.newBuilder();
        JsonFormat.parser().merge(requestBody, requestBuild);
        open.douyin.com.model.Login.UserDataRequest request = requestBuild.build();
        String token = request.getToken();
        UserSession cacheData = Store.GetCache(token);

        // 从cache中获取用户数据
        open.douyin.com.model.Login.UserDataResponse.Builder builder = open.douyin.com.model.Login.UserDataResponse.newBuilder();
        open.douyin.com.model.Login.UserData.Builder userDataBuilder = Login.UserData.newBuilder();
        userDataBuilder.setData(Mask.MaskPhoneNumber(cacheData.getData()));

        return JsonFormat.printer().print(builder.build());
    }
}
