<?php

namespace App\Controllers;

require_once(APPPATH."Store/Store.php");

use Model\LoginRequest;
use Model\LoginResponse;

class LoginController extends BaseController
{
    /**
     * @throws \Exception
     */
    public function login(): string
    {
        $this->response->setHeader("Content-Type", "application/json");
        try {
            // TODO 规范化
            $json = $this->request->getBody();
            $loginRequest = new LoginRequest();
            $loginRequest->mergeFromJsonString($json, true);

            $code2SessionMap = array("appid"=>$_SERVER['APP_ID'], "secret"=>$_SERVER['SECRET'], "code"=>$loginRequest->getCode());
            $code2SessionReqBody = json_encode($code2SessionMap);

            $domain = "developer.toutiao.com";
            if ($_SERVER['IS_SAND_BOX'] == "1") {
                $domain = "open-sandbox.douyin.com";
            }
            $code2SessionRespBody = \App\Utils\HttpUtils::HttpPost("/api/apps/v2/jscode2session", $code2SessionReqBody, "https", $domain);

            $code2SessionResp = json_decode($code2SessionRespBody, true);

            $loginResponse = new LoginResponse();
            if (empty($code2SessionResp)) {
                $loginResponse->setErrCode(-1);
                $loginResponse->setErrMsg("error");
                return $loginResponse->serializeToJsonString();
            }
            if ($code2SessionResp['err_no'] != 0 || empty($code2SessionResp["data"])) {
                $loginResponse->setErrCode(-1);
                $loginResponse->setErrMsg("error");
                return $loginResponse->serializeToJsonString();
            }

            $loginResponse->setErrCode(0);
            $loginResponse->setErrMsg("success");

            $token = \App\Store\Store::setCache("", $code2SessionResp["data"]["openid"], $code2SessionResp["data"]["unionid"], "", $code2SessionResp["data"]["session_key"]);
            $loginResponse->setToken($token);
            $loginResponse->setOpenid($this->dataDesensitization($code2SessionResp["data"]["openid"], 3, 7));
            $loginResponse->setUnionid($this->dataDesensitization($code2SessionResp["data"]["unionid"], 3, 7));
            return $loginResponse->serializeToJsonString();
        } catch (\Exception $e) {
            return $e->getMessage();
        }
    }


    function dataDesensitization($string, $start = 0, $length = 0, $re = '*')
    {
        if (empty($string)){
            return false;
        }
        $strarr = array();
        $mb_strlen = mb_strlen($string);
        while ($mb_strlen) {//循环把字符串变为数组
            $strarr[] = mb_substr($string, 0, 1, 'utf8');
            $string = mb_substr($string, 1, $mb_strlen, 'utf8');
            $mb_strlen = mb_strlen($string);
        }
        $strlen = count($strarr);
        $begin = $start >= 0 ? $start : ($strlen - abs($start));
        $end = $last = $strlen - 1;
        if ($length > 0) {
            $end = $begin + $length - 1;
        } elseif ($length < 0) {
            $end -= abs($length);
        }
        for ($i = $begin; $i <= $end; $i++) {
            $strarr[$i] = $re;
        }
        if ($begin >= $end || $begin >= $last || $end > $last) return false;
        return implode('', $strarr);
    }
}
