<?php

namespace App\Controllers;

require_once(APPPATH."Store/Store.php");

use App\Store\Mask;
use App\Store\Store;
use App\Utils\CbcCoding;
use Model\ShowDataRequest;
use Model\ShowDataResponse;

class ShowDataController extends BaseController
{
    public function showData()
    {
        $this->response->setHeader("Content-Type", "application/json");
        try {
            $json = $this->request->getBody();
            $showDataReq = new ShowDataRequest();
            $showDataReq->mergeFromJsonString($json, true);
            $showDataResp = new ShowDataResponse();

            log_message('critical', $json);
            $userData = \App\Store\Store::getCache($showDataReq->getToken());

            if (empty($userData)) {
                $showDataResp->setErrCode(-1);
                $showDataResp->setErrMsg("token not exist");
                return $showDataResp->serializeToJsonString();
            }

            log_message('critical', $showDataReq->getToken());
            $decodeKey = base64_decode($userData["sessionKey"]);

            $decodeData = base64_decode($showDataReq->getEncryptedData()->getData());
            $decodeIv = base64_decode($showDataReq->getEncryptedData()->getIv());
            $decryptData = CbcCoding::decrypt($decodeData, $decodeKey, $decodeIv);
            if (!$decryptData) {
                $showDataResp->setErrCode(-1);
                $showDataResp->setErrMsg("error");
                return $showDataResp->serializeToJsonString();
            }

            $showDataResp->setDecryptedData(Mask::MaskPhoneNumber($decryptData));
            $showDataResp->setErrCode(0);
            $showDataResp->setErrMsg("success");

            $token = \App\Store\Store::setCache("", $userData["openId"], $userData["unionId"], $decryptData, $userData["sessionKey"]);
            $showDataResp->setToken($token);
            return $showDataResp->serializeToJsonString();
        } catch (\Exception $e) {
            return $e->getMessage();
        }
    }
}
