<?php

namespace App\Controllers;

require_once(APPPATH."Store/Store.php");

use App\Store\Mask;
use Model\UserData;
use Model\UserDataRequest;
use Model\UserDataResponse;

class UserDataController extends BaseController
{
    /**
     * @throws \Exception
     */
    public function userData()
    {
        $this->response->setHeader("Content-Type", "application/json");
        $json = $this->request->getBody();
        $userDataReq = new UserDataRequest();
        $userDataReq->mergeFromJsonString($json, true);
        $data = \App\Store\Store::getCache($userDataReq->getToken());

        $userData = new UserData();
        $userData->setData(Mask::MaskPhoneNumber($data["data"]));

        $userDataResp = new UserDataResponse();
        $userDataResp->setUserData($userData);

        return $userDataResp->serializeToJsonString();
    }
}
