<?php

namespace App\Store;

class Store
{
    public static function genToken(): string
    {
        return uniqid();
    }

    public static function setCache($token, $openid, $unionid, $data, $sessionKey): string {
        $cache = \Config\Services::cache();
        if (!empty($token) && !empty($cachedData)) {
            $cacheData = $cache->get($token);
            if (!empty($data)) {
                $cacheData["data"] = $data;
            }
            if (!empty($openid)) {
                $cacheData["openId"] = $openid;
            }
            if (!empty($unionid)) {
                $cacheData["unionId"] = $unionid;
            }
            if (!empty($token)) {
                $cacheData["token"] = $token;
            }
            if (!empty($sessionKey)) {
                $cacheData["sessionKey"] = $sessionKey;
            }
            $cache->save($token, $cacheData);
            return $token;
        }

        $cacheData = [];
        $cacheData["data"] = $data;
        $cacheData["openId"] = $openid;
        $cacheData["unionId"] = $unionid;
        $cacheData["sessionKey"] = $sessionKey;
        $newToken = self::genToken();
        $cacheData["token"] = $newToken;

        $cache->save($newToken, $cacheData);

        return $newToken;
    }

    public static function getCache($token) {
        $cache = \Config\Services::cache();
        return $cache->get($token);
    }
}