import sys

from flask import Flask, request

import conf.app
import handler.login_handler
import handler.logout_handler
import handler.show_data_handler
import handler.user_data_handler

app = Flask(__name__)


@app.route('/')
def hello_world():
    return 'Hello World!'


@app.route('/api/apps/login', methods=['POST'])
def login():
    return handler.login_handler.login_handler(request.data), 200, [("Content-Type", "application/json;")]


@app.route('/api/apps/logout', methods=['POST'])
def logout():
    return handler.logout_handler.logout_handler(request.data), 200, [("Content-Type", "application/json;")]


@app.route('/api/apps/showData', methods=['POST'])
def show_data():
    return handler.show_data_handler.show_data_handler(request.data), 200, [("Content-Type", "application/json;")]


@app.route('/api/apps/userData', methods=['POST'])
def user_data():
    return handler.user_data_handler.user_data_handler(request.data), 200, [("Content-Type", "application/json;")]


def main(argv):
    parse_argv(argv)


def parse_argv(argv):
    if len(argv) < 2:
        return
    else:
        for arg in argv:
            arg_pair = arg.split("=")
            if len(arg_pair) == 2:
                conf.app.set_conf(arg_pair[0], arg_pair[1])


if __name__ == '__main__':
    print("run")
    main(sys.argv)
    print(conf.app.get_host_ports())
    hosts = conf.app.get_host_ports().split(":")
    app.run(host=hosts[0], port=hosts[1])
