import json
import conf.app
import utils.http_utils
import store.store

from model import login_pb2
from google.protobuf.json_format import MessageToJson, Parse


def login_handler(login_req_body):
    # 解析登录请求参数
    login_req = Parse(login_req_body, login_pb2.LoginRequest(), True)
    code2session_req = {'appid': conf.app.get_app_id(), 'secret': conf.app.get_secret(), 'code': login_req.code}
    code2session_res = utils.http_utils.http_post('https://developer.toutiao.com/api/apps/v2/jscode2session',
                                                  code2session_req)

    print(code2session_res)
    data = json.loads(code2session_res)

    login_res = login_pb2.LoginResponse()
    if data['err_no'] != 0:
        login_res.errCode = -1
        login_res.errMsg = 'error'
        return MessageToJson(login_res)
    else:
        login_res.errCode = 0
        login_res.errMsg = 'success'
        login_res.token = store.store.set_cache(
            "", data['data']['openid'], data['data']['unionid'], "", data['data']['session_key'])

        login_res.openid = data['data']['openid'][:3] + "****" + data['data']['openid'][7:]
        login_res.unionid = data['data']['unionid'][:3] + "****" + data['data']['unionid'][7:]
    return MessageToJson(login_res)
