import base64
import json
import conf.app
import store.store
import utils.http_utils
import utils.cbc_coding
import utils.mask

from model import login_pb2
from google.protobuf.json_format import MessageToJson, Parse


def show_data_handler(login_req_body):
    # 解析登录请求参数，并http调用code2session
    show_data_req = Parse(login_req_body, login_pb2.ShowDataRequest(), True)

    user_data = store.store.get_cache(show_data_req.token)
    # 解密用户加密数据
    decode_session_key = base64.b64decode(user_data.get_session_key())

    decode_data = base64.b64decode(show_data_req.encryptedData.data)
    decode_iv = base64.b64decode(show_data_req.encryptedData.iv)
    decrypt_data = utils.cbc_coding.decrypt(decode_data, decode_session_key, decode_iv)

    token = store.store.set_cache(show_data_req.token, user_data.get_open_id(), user_data.get_union_id(), decrypt_data,
                                  user_data.get_session_key())

    show_data_res = login_pb2.ShowDataResponse()
    show_data_res.decryptedData = utils.mask.mask_phone(decrypt_data)
    show_data_res.token = token

    return MessageToJson(show_data_res)
